<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import type { Ref } from 'vue';
import { ref, inject } from 'vue';
import { useRoute, useRouter } from 'vue-router';
import { useI18n } from 'vue-i18n';
import { request } from '@/lib/request';

type dashboardItem = {
    background_color: string,
    background_image: string,
    hash_pane: string,
    headline: string,
    last_update: string,
    mail: string,
    subheadline: string,
    type: string,
}

const { t } = useI18n();
const $t = t;

const route = useRoute();
const router = useRouter();
const configuration = inject<any>('configuration');
const apiServer = configuration.apiServer;
const basePath = configuration.basePath;

let data: Ref<dashboardItem[]> = ref([]);

const getData = () => {
    if (route.params.id) {
        request('GET', configuration.apiServer + '/api/overview/' + route.params.id).then((result: any) => {
            if (result.success) {
                data.value = result.data;
                if (result.data.length > 0)
                    document.title = t('dashboard.overview') + result.data[0].mail
            } else {
                //router.push({name: "home"});
            }
        });
    } else {
        router.push({ name: "home" });
    }
}

getData();

const getStyleOfGridItem = (item: dashboardItem) => {
    let style: { [k: string]: any } = { backgroundColor: item.background_color };
    if (item.background_image !== null)
        style.backgroundImage = `url(${apiServer + item.background_image})`
    return style;
}

const getLastUpdateISO = (date: string) => {
    return new Date(date).toISOString();
}

const getLastUpdate = (date: string) => {
    return new Date(date).toLocaleDateString('de-DE', { year: 'numeric', month: 'long', day: 'numeric' });
}

const goToCreate = () => {
    router.push({ name: "create-pane" });
}

</script>
<template>
    <div>
        <div class="flow-root box-content max-w-xl mx-auto px-4 uk-margin-large-top uk-margin-large-bottom uk-padding">
            <h3 class="uk-heading-divider">
                <div class="uk-flex-center" uk-grid>
                    <div style="margin-right:auto"></div>
                    <div>
                        <span class="uk-text-center">{{ $t("dashboardPage.title") }}</span>
                    </div>
                    <div style="margin-left:auto">
                        <ul class="uk-subnav uk-subnav-pill" uk-switcher="connect: .appearence">
                            <li class="uk-active">
                                <a class="oval" href="#" uk-icon="grid"></a>
                            </li>
                            <li>
                                <a class="oval" href="#" uk-icon="list"></a>
                            </li>
                        </ul>
                    </div>
                </div>
            </h3>
            <ul class="uk-switcher appearence">
                <li>
                    <div uk-filter="target: .type-filter">
                        <div class="uk-grid-small uk-grid-divider uk-child-width-auto uk-flex-center" uk-grid>
                            <div>
                                <ul class="uk-subnav uk-subnav-pill">
                                    <li class="oval uk-active" uk-filter-control>
                                        <a class="oval" href="#">{{ $t("dashboardPage.types.all") }}</a>
                                    </li>
                                    <li class="oval" uk-filter-control="[data-type='Freeform']">
                                        <a class="oval" href="#">{{ $t("dashboardPage.types.freeform") }}</a>
                                    </li>
                                    <li class="oval" uk-filter-control="[data-type='Schedule']">
                                        <a class="oval" href="#">{{ $t("dashboardPage.types.schedule") }}</a>
                                    </li>
                                    <li class="oval" uk-filter-control="[data-type='Stream']">
                                        <a class="oval" href="#">{{ $t("dashboardPage.types.stream") }}</a>
                                    </li>
                                    <li class="oval" uk-filter-control="[data-type='Timeline']">
                                        <a class="oval" href="#">{{ $t("dashboardPage.types.timeline") }}</a>
                                    </li>
                                </ul>
                            </div>
                            <div>
                                <ul class="uk-subnav uk-subnav-pill">
                                    <li class="uk-active" uk-filter-control="sort: data-date; order: desc">
                                        <a class="oval" href="#">{{ $t("dashboardPage.filterBy.date.lastVisited") }} ({{
                                            $t("dashboardPage.filterBy.date.descendingLabel") }})</a>
                                    </li>
                                    <li uk-filter-control="sort: data-date">
                                        <a class="oval" href="#">{{ $t("dashboardPage.filterBy.date.lastVisited") }} ({{
                                            $t("dashboardPage.filterBy.date.ascendingLabel") }})</a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                        <div class="uk-child-width-1-1@s uk-child-width-1-2@m uk-child-width-1-3@l type-filter" uk-grid
                            uk-height-match="target: > div > .relative box-border transition duration-100 ease-in-out rounded-lg > .uk-card-body">
                            <div :key="index" :data-type="item.type" :data-date="getLastUpdateISO(item.last_update)"
                                v-for="item, index in data">
                                <div class="uk-inline oval uk-box-shadow-medium item-card"
                                    :style="getStyleOfGridItem(item)">
                                    <div class="uk-overlay uk-overlay-default uk-position-bottom oval">
                                        <span v-if="item.type === 'Schedule'"
                                            class="uk-margin-remove uk-badge schedule-badge"
                                            :uk-tooltip='$t("dashboardPage.types.schedule")'>{{
                                                $t("dashboardPage.types.schedule")[0] }}</span>
                                        <span v-else-if="item.type === 'Freeform'"
                                            class="uk-margin-remove uk-badge freeform-badge"
                                            :uk-tooltip='$t("dashboardPage.types.freeform")'>{{
                                                $t("dashboardPage.types.freeform")[0] }}</span>
                                        <span v-else-if="item.type === 'Stream'"
                                            class="uk-margin-remove uk-badge stream-badge"
                                            :uk-tooltip='$t("dashboardPage.types.stream")'>{{
                                                $t("dashboardPage.types.stream")[0] }}</span>
                                        <span v-else-if="item.type === 'Timeline'"
                                            class="uk-margin-remove uk-badge timeline-badge"
                                            :uk-tooltip='$t("dashboardPage.types.timeline")'>{{
                                                $t("dashboardPage.types.timeline")[0] }}</span>

                                        <h4 class="uk-margin-remove-top uk-card-title dashboard-text">{{ item.headline }}
                                        </h4>
                                        <b class="uk-text-meta dashboard-text">{{ item.subheadline }}</b>
                                        <p class="uk-text-meta dashboard-text uk-margin-small-top">{{
                                            $t("dashboardPage.filterBy.date.lastVisited") }}:
                                            <span>{{ getLastUpdate(item.last_update) }}</span>
                                        </p>
                                        <a class="uk-button uk-button-accent uk-margin-top uk-align-right" target="_blank"
                                            rel="opener" :href="basePath + 't/' + item.hash_pane">{{
                                                $t("dashboardPage.buttonPane") }}</a>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </li>
                <li>
                    <div uk-filter="target: .table-filter">
                        <div class="uk-grid-small uk-grid-divider uk-child-width-auto uk-flex-center" uk-grid>
                            <div>
                                <ul class="uk-subnav uk-subnav-pill">
                                    <li class="oval uk-active" uk-filter-control>
                                        <a class="oval" href="#">{{ $t("dashboardPage.types.all") }}</a>
                                    </li>
                                    <li class="oval" uk-filter-control="[data-type='Freeform']">
                                        <a class="oval" href="#"> {{ $t("dashboardPage.types.freeform") }}</a>
                                    </li>
                                    <li class="oval" uk-filter-control="[data-type='Schedule']">
                                        <a class="oval" href="#"> {{ $t("dashboardPage.types.schedule") }}</a>
                                    </li>
                                    <li class="oval" uk-filter-control="[data-type='Stream']">
                                        <a class="oval" href="#"> {{ $t("dashboardPage.types.stream") }}</a>
                                    </li>
                                    <li class="oval" uk-filter-control="[data-type='Timeline']">
                                        <a class="oval" href="#"> {{ $t("dashboardPage.types.timeline") }}</a>
                                    </li>
                                </ul>
                            </div>
                            <div>
                                <ul class="uk-subnav uk-subnav-pill">
                                    <li class="uk-active" uk-filter-control="sort: data-date; order: desc">
                                        <a class="oval" href="#">{{ $t("dashboardPage.filterBy.date.lastVisited") }} ({{
                                            $t("dashboardPage.filterBy.date.descendingLabel") }})</a>
                                    </li>
                                    <li uk-filter-control="sort: data-date">
                                        <a class="oval" href="#">{{ $t("dashboardPage.filterBy.date.lastVisited") }} ({{
                                            $t("dashboardPage.filterBy.date.ascendingLabel") }}) </a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                        <ul class="uk-list uk-list-divider">
                            <li>
                                <div class="uk-grid" uk-grid>
                                    <div style="width:25px"></div>
                                    <div class="uk-width-expand"> {{ $t("adjustPanel.general.headline") }}</div>
                                    <div class="uk-width-expand"> {{ $t("adjustPanel.general.subheadline") }}</div>
                                    <div class="uk-width-1-6"> {{ $t("dashboardPage.filterBy.date.lastVisited") }}</div>
                                    <div style="width:160px"></div>
                                </div>
                            </li>
                            <li class="table-filter">
                                <div class="uk-grid" :key="index" :data-type="item.type"
                                    :data-date="getLastUpdateISO(item.last_update)" v-for="item, index in data">
                                    <div style="width:25px;margin-top:9px">
                                        <span v-if="item.type === 'Schedule'"
                                            class="uk-margin-remove uk-badge schedule-badge"
                                            :uk-tooltip='$t("dashboardPage.types.schedule")'>{{
                                                $t("dashboardPage.types.schedule")[0] }}</span>
                                        <span v-else-if="item.type === 'Freeform'"
                                            class="uk-margin-remove uk-badge freeform-badge"
                                            :uk-tooltip='$t("dashboardPage.types.freeform")'>{{
                                                $t("dashboardPage.types.freeform")[0] }}</span>
                                        <span v-else-if="item.type === 'Stream'"
                                            class="uk-margin-remove uk-badge stream-badge"
                                            :uk-tooltip='$t("dashboardPage.types.stream")'>{{
                                                $t("dashboardPage.types.stream")[0] }}</span>
                                        <span v-else-if="item.type === 'Timeline'"
                                            class="uk-margin-remove uk-badge timeline-badge"
                                            :uk-tooltip='$t("dashboardPage.types.timeline")'>{{
                                                $t("dashboardPage.types.timeline")[0] }}</span>
                                    </div>
                                    <div class="uk-width-expand uk-margin-small">{{ item.headline }}</div>
                                    <div class="uk-width-expand uk-margin-small">{{ item.subheadline }}</div>
                                    <div class="uk-width-1-6 uk-margin-small">{{ getLastUpdate(item.last_update) }}</div>
                                    <div style="width:160px">
                                        <a class="uk-button uk-button-small uk-button-accent" target="_blank" rel="opener"
                                            :href="basePath + 't/' + item.hash_pane"> {{ $t("dashboardPage.buttonPane")
                                            }}</a>
                                    </div>
                                </div>
                            </li>
                        </ul>
                    </div>
                </li>
            </ul>
        </div>
        <div class="uk-inline" style="position: fixed !important;bottom:20px;right:20px;z-index:999;">
            <div class="uk-button uk-button-primary" uk-icon="plus"
                :uk-tooltip='"title:" + $t("dashboardPage.addButton.label")' @click="goToCreate"></div>
        </div>
    </div>
</template>
<style>
.item-card {
    height: 300px;
    width: 100%;
    background-size: cover;
}</style>